//+------------------------------------------------------------------+
//|                                                      T101_VininE |
//|                                Copyright  2008, Victor Nicolaev |
//|                                            e-mail: vinin@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Victor Nicolaev"
#property link      "e-mail: vinin@mail.ru"

#include <WinUser32.mqh>

extern bool    CheckNevBar    = true;
extern double  Lot            = 0.1;
extern int     ShiftBack      = 8;
extern int     CorrelationBar = 27;
extern string  ListSymbol     = "AUDCAD,AUDCHF,AUDJPY,AUDNZD,AUDUSD,CADCHF,CADJPY,CHFJPY,EURAUD,EURCAD,EURCHF,EURJPY,EURGBP,EURNZD,EURUSD,NZDUSD,NZDJPY,GBPUSD,GBPCHF,GBPJPY,USDCHF,USDJPY,USDCAD";
extern int     StopLoss       = 100;
extern int     TakeProfit     = 100;
extern int     Magic          = 20081018;
extern int     pos            = 1;
extern int     Slip           = 3;
extern int     MaxProfit      = 1000;
//+------------------------------------------------------------------+
double   WorkPips[];
string   WorkSymbol[];
int      WorkOp[],
         WorkSort[],
         WorkCorr[],
         WorkTicket[],
         WorkCount,
         Order_Count[6],
         gi_BrokerDecimal;
string   NameOP[] = {"BUY","SELL","BUYLIMMIT","SELLLIMIT","BUYSTOP","SELLSTOP"};
int      week_back;
int      shift = 0;
int      WorkPrevTime = 0;
int      Ind_Base = -1;
int      reversi = -1;
//+------------------------------------------------------------------+
int init()
{
    string ls_inf = "   :\n";
//----
    //            -      10  -     
    if (Digits == 3 || Digits == 5)
    {gi_BrokerDecimal = 10;}
     //       
    else
    {gi_BrokerDecimal = 1;}
    StopLoss = StopLoss * gi_BrokerDecimal;
    TakeProfit = TakeProfit * gi_BrokerDecimal;
    Slip = Slip * gi_BrokerDecimal;
//----
    WorkCount = 0;
    ArrayResize (WorkSymbol, 100);
    int i1 = 0, i2 = 0;
    //    1-  
    i2 = StringFind (ListSymbol, ",", i1);
    while (i2 > 0)
    {
        WorkSymbol[WorkCount] = StringSubstr (ListSymbol, i1, i2 - i1);
        WorkCount++;
        i1 = i2 + 1;
        i2 = StringFind (ListSymbol, ",", i1 + 1);
    }
    WorkSymbol[WorkCount] = StringSubstr (ListSymbol, i1);
    WorkCount++;
    for (int l_int = 0; l_int < WorkCount; l_int++)
    {ls_inf = StringConcatenate (ls_inf, WorkSymbol[l_int], "; ");}
    Print (ls_inf);
    if (IsTesting() || IsOptimization())
    {WorkCount = 1;}
    ArrayResize (WorkSymbol, WorkCount);
    ArrayResize (WorkOp, WorkCount);
    ArrayResize (WorkPips, WorkCount);
    ArrayResize (WorkSort, WorkCount);
    ArrayResize (WorkCorr, WorkCount);
    ArrayResize (WorkTicket, WorkCount);

    ArrayInitialize (WorkOp, -1);
    ArrayInitialize (WorkSort, -1);
    ArrayInitialize (WorkCorr, 0);
    ArrayInitialize (WorkTicket, -1);
//----
    return (0);
}
//+------------------------------------------------------------------+
int deinit()
{return (0);}
//+------------------------------------------------------------------+
int start()
{
    int err;
    string ls_msg;
    if (CheckNevBar)
    {
        if (!WorkNevBar())
        {return (0);}
    }
    if (!fGetHistory())
    {
        ls_msg = "     !!!";
        Print (ls_msg);
        Comment (ls_msg);
        //return (0);
    }
    if (Lot == 0)
    {Lot = MarketInfo (Symbol(), MODE_MINLOT);}
    check_order (Magic);
    run_statistics();  
    run_sort();
    run_correlation (WorkSort[0]);
    run_trade (Magic);
    if (fGetProfit (Magic) >= MaxProfit)
    {CloseOrderAll (Magic);}
    err = GetLastError();
    if (err > 0)
    {Print (err);}
//----
    return (0);
}
//+------------------------------------------------------------------+
void check_order (int MG)
{
    ArrayInitialize (WorkTicket, -1);
    for (int i = 0; i < OrdersTotal(); i++)
    {
        if (!OrderSelect (i, SELECT_BY_POS, MODE_TRADES))
        {continue;}
        if (OrderMagicNumber() != MG)
        {continue;}
        for (int j = 0; j < WorkCount; j++)
        {
            if (OrderSymbol() == WorkSymbol[j])
            {
                WorkTicket[j] = OrderTicket();
                break;
            }
        }
    }
}
//+------------------------------------------------------------------+
void run_statistics()
{
    for (int i = 0; i < 14; i++)
    {WorkPips[i] = CalculatePips (WorkSymbol[i]);}
}
//+------------------------------------------------------------------+
void run_correlation (int Base)
{
    int i, j, err;
    double sx, sy, dx, dy, dxy, sb, co, sdxy;
   
    sx = iMA (WorkSymbol[Base], 0, CorrelationBar, 0, MODE_SMA, PRICE_CLOSE, pos);
    dx = 0;
    for (i = 0; i < CorrelationBar; i++)  
    {dx += MathPow (iClose (WorkSymbol[Base], 0, pos + i) - sx, 2);}
    for (j = 0; j < WorkCount; j++)
    {
        if (Base == j)
        {WorkCorr[j] = reversi;}
        else
        {
            sy = iMA (WorkSymbol[j], 0, CorrelationBar, 0, MODE_SMA, PRICE_CLOSE, pos);
            dy = 0;
            dxy = 0;
            for (i = 0; i < CorrelationBar; i++)
            {
                dy += MathPow (iClose (WorkSymbol[j], 0, pos + i) - sy, 2);
                dxy += (iClose (WorkSymbol[Base], 0, pos + i) - sy) * (iClose (WorkSymbol[j], 0, pos + i) - sy);
            }
            sdxy = MathSqrt (dx * dy);
            WorkCorr[j] = 0;
            if (sdxy != 0)
            {
                dxy /= sdxy;
                if (dxy > 0.7)
                {WorkCorr[j] = reversi;}
                if (dxy < -0.7)
                {WorkCorr[j] = -reversi;}
            }         
        }
    }
    err = GetLastError();
    if (err > 0)
    {Print (err);}
}
//+------------------------------------------------------------------+
double CalculatePips (string Sym)
{
    int err;
    double ld_Point, m, m_now, m_pips;
    if (StringLen (Sym) == 0)
    {return (0);}
    ld_Point = dPoint (Sym);
    if (ld_Point == 0)
    {return (0);}
    m_pips = (iClose (Sym, 0, 0) - iOpen (Sym, 0, ShiftBack)) / ld_Point;
    err = GetLastError();
    if (err > 0)
    {Print (err);}
//----
    return (m_pips);
}
//+------------------------------------------------------------------+
void run_sort()
{
    int i, j, tmp;
//----
    for (i = 0; i < WorkCount; i++)
    {WorkSort[i] = i;}
   
    for (i = 0; i < WorkCount; i++)
    {
		for (j = i + 1; j < WorkCount; j++)
		{
			if (WorkPips[WorkSort[i]] < WorkPips[WorkSort[j]])
			{
				tmp = WorkSort[j]; 
				WorkSort[j] = WorkSort[i]; 
				WorkSort[i] = tmp;
			}
		}
	}
}
//+------------------------------------------------------------------+
bool analyze_trades()
{
    int i, sp, sm;
    sp = 0;
    sm = 0;
//----
    for (i = 0; i < WorkCount; i++)
    {
        if (WorkCorr[WorkSort[i]] == 1)
        {      
            if (WorkPips[WorkSort[i]] > 0)
            {sm++;}
            sp++;
        }
    }
    if (sp == 0 || sp != sm)
    {return (true);}
//----
    return (false);
}
//+------------------------------------------------------------------+
void run_trade (int MG)
{
    //  
    for (int i = 0; i < WorkCount; i++)
    {
        if (WorkTicket[i] == -1)
        {continue;}
        OrderSelect (WorkTicket[i], SELECT_BY_TICKET);
        if (OrderCloseTime() > 0)
        {WorkTicket[i] = -1;}
        else
        {
            if (WorkCorr[i] == 0)
            {
                Order_Close (WorkSymbol[i], MG);
                WorkTicket[i] = -1;
            }
            if (WorkCorr[i] == 1 && OrderType() == OP_SELL)
            {
                Order_Close (WorkSymbol[i], MG, OP_SELL);
                WorkTicket[i] = -1;
            }
            if (WorkCorr[i] == -1 && OrderType() == OP_BUY)
            {
                Order_Close (WorkSymbol[i], MG, OP_BUY);
                WorkTicket[i] = -1;
            }
        }
    }
    for (i = 0; i < WorkCount; i++)
    {
        if (WorkTicket[i] >= 0 || WorkCorr[i] == 0)
        {continue;}
        if (WorkCorr[i] == 1)
        {WorkTicket[i] = Order_Open (WorkSymbol[i], MG, OP_BUY);}
        else
        {WorkTicket[i] = Order_Open (WorkSymbol[i], MG, OP_SELL);}
    }
}
//+------------------------------------------------------------------+
double dPoint (string sym)
{
    double ld_Point = MarketInfo (sym, MODE_POINT);
    if (ld_Point == 0)
    {ld_Point = 1 / MathPow (10, MarketInfo (sym, MODE_DIGITS));}
//----
    return (ld_Point);
}
//+------------------------------------------------------------------+
bool WorkNevBar()
{
    int NevTime = Time[0];
    if (WorkPrevTime == NevTime)
    {return (false);}
    WorkPrevTime = NevTime;
//----
    return (true);
}
//+------------------------------------------------------------------+
//   
//+------------------------------------------------------------------+
double iif (bool A, double B, double C)
{
    if (A)
    {return (B);}
//----
    return (C);
}
//+------------------------------------------------------------------+
//   
//+------------------------------------------------------------------+
int Order_Open (string Sym, int MG, int OP)
{
    int err;
    if (!CheckSymbol (Sym))
    {return (-1);}
    RefreshRates();

    int cmd = iif (OP == OP_BUY, 1, -1);
    double ld_ask = MarketInfo (Sym, MODE_ASK);
    double ld_bid = MarketInfo (Sym, MODE_BID);
    double ld_point = MarketInfo (Sym, MODE_POINT);
    double ld_digits = MarketInfo (Sym, MODE_DIGITS);
    double price = iif (OP == OP_BUY, ld_ask, ld_bid);
    double ld_sl = NormalizeDouble (iif (StopLoss == 0, 0, price - cmd * StopLoss * ld_point), ld_digits);
    double ld_tp = NormalizeDouble (iif (TakeProfit == 0, 0, price + cmd * TakeProfit * ld_point), ld_digits);
    string ls_comment = WorkSymbol[WorkSort[0]];
    int ticket = OrderSend (Sym, OP,  Lot, price, Slip, ld_sl, ld_tp, ls_comment, MG, 0); 
    err = GetLastError();
    if (err > 0)
    {
       if (err == 129)
       {Print ("Order Open error[", Sym, "] = ", err, ": ", "; price = ", price, "; Close = ", iClose (Sym, 0, 0));}
       else {Print ("Order Open error[", Sym, "] = ", err, ": ", OP, ", ",  Lot, ", ", price, ", ", ld_sl, ", ", ld_tp, ", " , ls_comment);}
    }
//----
    return (ticket);
}
//+------------------------------------------------------------------+
void Order_Close (string WorkSymbol, int MG, int OP = -1)
{
    bool res;
//----
    for (int i = OrdersTotal() - 1;  i >= 0;  i--)
    {
        if (!OrderSelect (i, SELECT_BY_POS, MODE_TRADES))
        {continue;}
        if (OrderMagicNumber() != MG)
        {continue;}
        if (OrderType() != OP && OP != -1)
        {continue;}
      
        RefreshRates();
      
        double ld_ask = MarketInfo (OrderSymbol(), MODE_ASK);
        double ld_bid = MarketInfo (OrderSymbol(), MODE_BID);
        double ld_digits = MarketInfo (OrderSymbol(), MODE_DIGITS);
        double ClosePrice = NormalizeDouble (iif (OrderType() == OP_BUY, ld_bid, ld_ask), ld_digits);
        res = OrderClose (OrderTicket(), OrderLots(), ClosePrice, Slip);
    }
}
//+------------------------------------------------------------------+
//          
//+------------------------------------------------------------------+
int Order_Count_Calculate (string WorkSymbol, int MG, int OP = -1)
{
    ArrayInitialize (Order_Count, 0);
    for (int i = OrdersTotal() - 1;  i >= 0;  i--)
    {
        if (!OrderSelect (i, SELECT_BY_POS, MODE_TRADES))
        {continue;}
        if (OrderSymbol() != WorkSymbol)
        {continue;}
        if (OrderMagicNumber() != MG)
        {continue;}
        if (OrderType() != OP && OP != -1)
        {continue;}
        Order_Count[OrderType()]++;
    }
    if (OP != -1)
    {return (Order_Count[OP]);}
}
//+------------------------------------------------------------------+
bool CheckSymbol (string WorkSymbol)
{
    if ((IsTesting() || IsOptimization()) && WorkSymbol != Symbol())
    {return (false);}
//----
    return (true);
}
//+------------------------------------------------------------------+
void CloseOrderAll (int MG)
{
    for (int i = OrdersTotal() - 1; i >= 0; i--)
    {
        if (!OrderSelect (i, SELECT_BY_POS, MODE_TRADES))
        {continue;}
        if (OrderMagicNumber() != MG)
        {continue;}
        OrderClose (OrderTicket(), OrderLots(), OrderClosePrice(), Slip);
    }
}
//+------------------------------------------------------------------+
double fGetProfit (int MG)
{
    double ld_Profit = 0.0;
    for (int i = OrdersTotal() - 1; i >= 0; i--)
    {
        if (!OrderSelect (i, SELECT_BY_POS, MODE_TRADES))
        {continue;}
        if (OrderMagicNumber() != MG)
        {continue;}
        ld_Profit += OrderProfit();
    }
//----
    return (ld_Profit);
}
//+------------------------------------------------------------------+
bool fGetHistory()
{
    string msg, symbol;
    int l_int, j, li_Period = Period();
    double x, z;
//----
    if (!IsCondition())
    {return (false);}
    for (l_int = 0; l_int < WorkCount; l_int++) 
    {
        symbol = WorkSymbol[l_int];
        msg = StringConcatenate ("\n  ", symbol, ", ", GetNameTF (li_Period));
        Comment (msg);
        for (j = 100; j >= 0; j--) 
        {
            x = iClose (symbol, li_Period, j + 1);
            z = iOpen (symbol, li_Period, j);
        }
        Sleep (50);
        msg = StringConcatenate ("\n  ", symbol, " !");
        Comment (msg);
        Sleep (750);
    }
    msg = StringConcatenate ("\n   ", WorkCount, "   . C  : ", AccountNumber()); 
    Comment (msg);
    return (true);
}
//+------------------------------------------------------------------+
bool IsCondition()
{
    string msg2;
    bool result = true;
    string title2 = "";
    if (AccountNumber() > 0) 
    {title2 = AccountNumber() + ": " + title2;}
//----
    if (!IsConnected())
    {
        msg2 = "\n    !!!";
        result = false;
    }
    if (!IsDllsAllowed())
    {
        if (!result)
        {
            msg2 = StringConcatenate (title2, msg2, "\n     -= DLL=- !!!");
            result = false;
        }
    }
    Comment (msg2);
//----
    return (result);
}
//+----------------------------------------------------------------------------+
//|                                            |
//+----------------------------------------------------------------------------+
string GetNameTF (int TF)
{
    switch (TF)
    {
        case PERIOD_M1:  return ("M1");
		case PERIOD_M5:  return ("M5");
		case PERIOD_M15: return ("M15");
		case PERIOD_M30: return ("M30");
		case PERIOD_H1:  return ("H1");
		case PERIOD_H4:  return ("H4");
		case PERIOD_D1:  return ("D1");
		case PERIOD_W1:  return ("W1");
		case PERIOD_MN1: return ("Mth1");
		default:		 return ("UnknownPeriod");
	}
}

